package net.cattaka.slidepuzzle;

import java.sql.SQLException;
import java.util.List;

import net.cattaka.slidepuzzle.db.DbHandler;
import net.cattaka.slidepuzzle.dto.InData;
import net.cattaka.slidepuzzle.dto.Score;
import net.cattaka.slidepuzzle.solver.World;

public class AnswerValidator {
	public static String validateAnswers(InData inData, Score score) {
		World world = World.createWorld(inData.getBi(), inData.getWi(), inData.getHi());
		for (char c:score.getAnswer().toCharArray()) {
			world = world.getNext((byte) inData.getWi(), (byte) inData.getHi(), (byte) c);
		}
		for (int i=0;i<world.getTile().length;i++) {
			byte v = world.getTile()[i];
			if (v == 0 && i == world.getTile().length -1 ) {
				// ok
				continue;
			} else if (v == -1) {
				// ok
				continue;
			} else if (v>0 && v == i+1) {
				// ok
				continue;
			} else {
				String msg = String.format("Bad answer : Id=%d, SolverType=%d, Count=%d, Answer=%s", score.getId(), score.getSolverType(), score.getCount(), score.getAnswer());
				return msg;
			}
		}
		return null;
	}
	public static void validateAnswers() throws SQLException {
		DbHandler dbHandler = new DbHandler();
		dbHandler.initialize();
		List<Score> scores = dbHandler.findAllScore();
		for (Score score : scores) {
			InData inData = dbHandler.findIndata(score.getId());
			String msg = validateAnswers(inData, score);
			if (msg != null) {
				System.out.println(msg);
			}
		}
	}
	
	public static void main(String[] args) throws SQLException {
		validateAnswers();
	}
}
