package net.cattaka.slidepuzzle;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.sql.Connection;
import java.sql.SQLException;

import net.cattaka.slidepuzzle.db.DbHandler;
import net.cattaka.slidepuzzle.dto.InData;

public class InDataLoader {
	public static void loadInData(DbHandler dbHandler, BufferedReader reader) throws IOException, SQLException {
		String line;
		
		// 先頭２行は読み飛ばす
		reader.readLine();
		reader.readLine();
		int id = 0;
		Connection conn = dbHandler.getConnection();
		conn.setAutoCommit(false);
		while((line = reader.readLine()) != null && line.length() > 0) {
			id++;
			String[] tmp = line.split(",", 3);
			InData inData = new InData();
			inData.setId(id);
			inData.setWi(Integer.parseInt(tmp[0]));
			inData.setHi(Integer.parseInt(tmp[1]));
			inData.setBi(tmp[2]);
			dbHandler.registerInData(conn, inData);
		}
		conn.commit();
		conn.close();
	}
	public static void load() throws IOException, SQLException  {
		BufferedReader reader = new BufferedReader(new FileReader("problems.txt"));
		DbHandler dbHandler = new DbHandler();
		dbHandler.initialize();
		loadInData(dbHandler, reader);
	}
	public static void main(String[] args) throws Exception {
		load();
	}
	
}
