package net.cattaka.slidepuzzle.test;

import net.cattaka.slidepuzzle.AnswerValidator;
import net.cattaka.slidepuzzle.SolverException;
import net.cattaka.slidepuzzle.dto.InData;
import net.cattaka.slidepuzzle.dto.Score;
import net.cattaka.slidepuzzle.solver.Solver;
import net.cattaka.slidepuzzle.solver.UltimetSolver;
import net.cattaka.slidepuzzle.solver.World;
import net.cattaka.slidepuzzle.util.StringUtil;

public class UltimetSolverTest {
	public static void main(String[] args) {
		// test1();
		// test2();
		//test3();
		test4();
		//run();
	}

	public static void run() {

		 String dat ="23D4=1=C8E6B0A9";
		 byte wx = 5;
		 byte wy = 3;

		World world = World.createWorld(dat, wx, wy);

		Solver solver = new Solver();
		solver.initialize(world, 1);
		World result = solver.solve(300, 1000000, 1000000);
		System.out.println(solver.getSolveStage());
		System.out.println(world.toString());
		System.out.println(result.toString());
		System.out.println(StringUtil.conv(result.getExPath()));
	}

	public static void test4() {
		{
			InData[] inDatas = new InData[] {
				new InData(319,6,6,"40G9E31DJA56872F=BP===NZVWR=CUXQYTOI"),
				new InData(330,6,6,"721095D=3H=6JK=SICXEGA4=LPQNMTVWR=ZU"),
				new InData(655,5,4,"B6391C==A2ID045JHFGE"),
				new InData(690,4,6,"523861=E=ABJLCFHK0DNMI4G"),
				new InData(959,5,5,"38G9J2=KF41E5LAC=MI06BDNO"),
				new InData(1052,6,6,"D8236BKE==5410PVGJ7W=F=CX=YHUIRSMTZO"),
				new InData(1220,4,6,"214863=CD=GB90JIEH5KLFNM"),
				new InData(1260,6,6,"D124B5837=6CV=9FLYPJUKGHW=O0INXRMTSZ"),
				new InData(1275,6,6,"2H7345G0===6I1OUTCFD===Z=8XRES=QWJKY"),
				new InData(1542,4,6,"18LC73246=GB5=JF9=MKDH0N"),
				new InData(1801,4,6,"34FG2==81=B9L5HCND0KIMEJ"),
				new InData(1934,6,6,"=823BUP7=4CHJ==6INLRGO5ZV0KA=YWDSQMX"),
				new InData(2415,6,6,"====IA7890GCJ==BM5DYH6P=WKRNLTQV=ZSU"),
				new InData(2661,6,6,"7KF56C3DG4=I1J2AH98LV=0OPQ=UTNWEXSZY"),
				new InData(2765,6,6,"E405I=2LA3BC9P8NFO7J1KGZQD=UMHWV=SYT"),
				new InData(2790,4,6,"13A=2=CEDF78M95B0L=GIHNK"),
				new InData(3255,6,4,"E3456C2D1==0KJNF9H87==GI"),
				new InData(3318,6,6,"123===7=HBCSD=AGNIJ=PFZ=QWM9YT=RLX0U"),
				new InData(3325,5,5,"6A152B=43KGHDMELCF89NIJ0O"),
				new InData(3418,6,4,"==94BM8A3L0J7=FNI5DHKGC6"),
				new InData(3648,6,6,"371A4528=G=6=K=HCI=LN=O0WPEXUSVQZRYT"),
				new InData(3649,6,4,"293AH=1=740FLBIKGC=DE=5N"),
				new InData(3717,6,6,"=93450K72==6VPF8=NDJ=GMCXE===IWQYZUO"),
				new InData(4373,6,4,"1023BC7=95IHD=6=ML4FAKNJ"),
				new InData(4564,6,4,"9N10567=42IHEK=A3BJDLGMC"),
				new InData(4790,6,6,"=74638EF9==C2KDGHI50====J=RSTUPVWXYZ"),
			};
			StringBuffer sb = new StringBuffer();
			
			int count = 0;
			//for (int i=0;i<inDatas.length;i++) {
			{	int i=25;
				InData inData = inDatas[i]; 
			
				World world = World.createWorld(inData.getBi(), inData.getWi(), inData.getHi());
				UltimetSolver solver = null;
				
				try {
					World result;
					{
						UltimetSolver solver1 = new UltimetSolver();
						solver1.initialiez(world, true);
						World result1 = solver1.solve();

						UltimetSolver solver2 = new UltimetSolver();
						solver2.initialiez(world, false);
						World result2 = solver2.solve();
						
						if (result1.getExPath().length < result2.getExPath().length) {
							result = result1;
						} else {
							result = result2;
						}
					}
//					System.out.println(result);
//					System.out.println(StringUtil.conv(result.getExPath()));
//					System.out.println(StringUtil.conv(SolverUtil.compact(result.getExPath())));
					
					Score score = new Score();
					score.setId(inData.getId());
					score.setSolverType(4);
					score.setAnswer(StringUtil.conv(result.getExPath()));
					String msg = AnswerValidator.validateAnswers(inData, score);
					if (msg != null) {
						sb.append(toString(inData));
						sb.append(" : ");
						sb.append(msg);
						sb.append("\n");
					} else {
						count += result.getExPath().length;
					}
				} catch (SolverException e) {
					e.printStackTrace();
					sb.append(toString(inData));
					sb.append("\n");
				}
			}
			System.out.println("====Unsolved====");
			System.out.println(sb.toString());
			System.out.println("================");
			System.out.println("Count : " + count);
		}
	}
	private static String toString(InData inData) {
		StringBuilder sb = new StringBuilder();
		sb.append(inData.getId());
		sb.append(" : ");
		sb.append(inData.getWi());
		sb.append(" : ");
		sb.append(inData.getHi());
		sb.append(" : ");
		sb.append(inData.getBi());
		return sb.toString();
	}
	
}
