package net.cattaka.slidepuzzle.util;

import java.util.List;

public class StringUtil {
	public static String conv(byte[] bs) {
		if (bs == null) {
			return "null";
		}
		StringBuilder sb = new StringBuilder(bs.length);
		for (byte b : bs) {
			sb.append((char)b);
		}
		return sb.toString();
	}
	public static String conv(List<Byte> bs) {
		if (bs == null) {
			return "null";
		}
		StringBuilder sb = new StringBuilder(bs.size());
		for (byte b : bs) {
			sb.append((char)b);
		}
		return sb.toString();
	}
	public static String convByte(byte[] weight, int wx, int wy) {
		StringBuffer sb = new StringBuffer();
		sb.append('\n');
		for (int y = 0; y < wy; y++) {
			for (int x = 0; x < wx; x++) {
				byte w = weight[x + wx * y];
				if (w == -1) {
					sb.append(" ==");
				} else {
					sb.append(String.format("%3d", w));
				}
			}
			sb.append('\n');
		}
		return sb.toString();
	}
	public static String convBoolean(boolean[] flags, int wx, int wy) {
		StringBuffer sb = new StringBuffer();
		sb.append('\n');
		for (int y = 0; y < wy; y++) {
			for (int x = 0; x < wx; x++) {
				sb.append((flags[x + wx * y]) ? 1 : 0);
			}
			sb.append('\n');
		}
		return sb.toString();
	}
}
